<script setup lang="ts">
    import { base64ToDataUrl, dataUrlToBase64 } from '@/shared/helpers/base64'
    import { getResizedDimensionsWithinBounds } from '@/shared/helpers/size'
    import { emitSnackBar } from '@/plugins/snackBarManager'
    import { SilabImage } from '@/shared/document/entities/SilabImage'
    import { getThumbnailUrl } from '@/shared/item/entities/ListableItem'
    import { computed, ref } from 'vue'
    import { useDisplay } from 'vuetify/lib/framework.mjs'
    import SPhotoCapture from './SPhotoCapture.vue'
    import { isMobile } from '@/shared/helpers/device'

    const galleryFileInput = ref<HTMLInputElement | undefined>(undefined)
    const cameraFileInput = ref<HTMLInputElement | undefined>(undefined)

    const hasCamera = ref<boolean>()
    navigator.mediaDevices.enumerateDevices().then((devices) => {
        hasCamera.value = devices.some((device) => device.kind === 'videoinput')
    })

    const isPhotoCaptureOpen = ref<boolean>(false)
    const isBottomSheetOpen = ref(false)

    const imagesColsXs = 4
    const imagesColsSm = 3
    const imagesColsMd = 3

    const currentBreakPoint = useDisplay().name

    const imagesPerRow = computed(() => {
        switch (currentBreakPoint.value) {
            case 'xs':
                return 12 / imagesColsXs
            case 'sm':
                return 12 / imagesColsSm
            default:
                return 12 / imagesColsMd
        }
    })

    const numberOfPlaceholders = computed(() => {
        const numberOfimages =
            props.addedImagesB64.length + (props.existingImages?.length ?? 0)

        return imagesPerRow.value - (numberOfimages % imagesPerRow.value)
    })

    interface Props {
        addedImagesB64: string[]
        existingImages?: SilabImage[]
        removedExistingImagesId?: string[]
        loading?: boolean
    }

    const props = withDefaults(defineProps<Props>(), {
        existingImages: () => [],
        removedExistingImagesId: () => [],
        loading: () => false,
    })
    const emit = defineEmits<{
        'update:existingImages': [SilabImage[]]
        'update:addedImagesB64': [string[]]
        'update:removedExistingImagesId': [string[]]
    }>()

    function uploadImageWithGalery() {
        isBottomSheetOpen.value = false
        galleryFileInput.value?.click()
    }
    function uploadImageWithCamera() {
        isBottomSheetOpen.value = false
        cameraFileInput.value?.click()
    }

    function resizeAndAddImage(rawImage: ImageBitmap, type: string) {
        const canvas = document.createElement('canvas')

        try {
            const [maxWidth, maxHeight] = [1920, 1080]

            const newDimensions = getResizedDimensionsWithinBounds(
                rawImage.width,
                rawImage.height,
                maxWidth,
                maxHeight
            )
            canvas.width = newDimensions.width
            canvas.height = newDimensions.height

            const ctx = canvas.getContext('2d')

            // Représente les coordonnées du canvas, en mettant (0, 0), on s'assure que l'image soit affichée complètement dans le canvas sans être coupée
            ctx?.drawImage(rawImage, 0, 0, canvas.width, canvas.height)
            // Crée une version compressée de l'image en utilisant le contenu du canvas généré précédemment
            const compressedDataUrl = canvas.toDataURL(
                type, // Spécifie le type de fichier de sortie de l'image compressée, qui est le même que celui de l'image d'origine
                0.9 // Avec un taux de compression de l'image à 0,9, on a un gain maximum pour une perte minimum de qualité d'image
            )

            const base64 = dataUrlToBase64(compressedDataUrl)
            emit('update:addedImagesB64', [...props.addedImagesB64, base64])
        } catch (error) {
            emitSnackBar((<Error>error).message)
        } finally {
            canvas.remove()
        }
    }

    function handleUploadGaleryImage(event: Event) {
        const file = (event.target as HTMLInputElement).files?.[0]
        if (file) {
            const reader = new FileReader()
            reader.addEventListener('load', () => {
                const image = new Image()
                image.onload = async () => {
                    // Crée une copie optimisée pour le rendu de l'image
                    const bitmap = await createImageBitmap(file)
                    resizeAndAddImage(bitmap, file.type)
                }
                image.src = reader.result as string
            })
            // Lit le contenu de l'objet et le renvoie sous forme de données URL codées en base64
            reader.readAsDataURL(file)
        }
    }

    function handleUploadCameraImage(capturedPhoto: ImageBitmap) {
        resizeAndAddImage(capturedPhoto, 'image/jpeg')
    }

    function removeAddedImageB64($imageB64: string) {
        emit(
            'update:addedImagesB64',
            props.addedImagesB64.filter(($imageB64Candidate) => {
                return $imageB64Candidate !== $imageB64
            })
        )
    }

    function removeExistingImage($imageId: string) {
        emit(
            'update:existingImages',
            props.existingImages.filter(($existingImageCandidate) => {
                return $existingImageCandidate.id !== $imageId
            })
        )
        emit('update:removedExistingImagesId', [
            $imageId,
            ...props.removedExistingImagesId,
        ])
    }
</script>
<template>
    <v-row>
        <input
            ref="galleryFileInput"
            type="file"
            accept="image/jpeg, image/png"
            data-cy="upload-image-button"
            class="d-none"
            @change="handleUploadGaleryImage"
        />
        <input
            ref="cameraFileInput"
            type="file"
            accept="image/jpeg, image/png"
            capture="environment"
            class="d-none"
            @change="handleUploadGaleryImage"
        />
        <v-col
            v-for="existingImage in existingImages"
            :key="existingImage.id"
            :cols="imagesColsXs"
            :sm="imagesColsSm"
            :md="imagesColsMd"
        >
            <v-img
                aspect-ratio="1"
                :src="existingImage.url.href"
                :lazy-src="getThumbnailUrl(existingImage.url, 60).href"
                cover
                class="rounded text-right pa-2"
            >
                <template #placeholder>
                    <v-row
                        class="fill-height ma-0"
                        align="center"
                        justify="center"
                    >
                        <v-progress-circular
                            indeterminate
                            color="grey lighten-5"
                        ></v-progress-circular>
                    </v-row>
                </template>
                <v-btn
                    icon="mdi-close"
                    size="x-small"
                    color="error"
                    @click="removeExistingImage(existingImage.id)"
                ></v-btn>
            </v-img>
        </v-col>
        <v-col
            v-for="addedImageB64 in addedImagesB64"
            :key="addedImageB64"
            :cols="imagesColsXs"
            :sm="imagesColsSm"
            :md="imagesColsMd"
        >
            <v-img
                aspect-ratio="1"
                :src="base64ToDataUrl(addedImageB64)"
                cover
                class="rounded text-right pa-2"
            >
                <v-btn
                    icon="mdi-close"
                    size="x-small"
                    color="error"
                    @click="removeAddedImageB64(addedImageB64)"
                ></v-btn>
            </v-img>
        </v-col>
        <v-col
            v-for="placeHolderIndex in numberOfPlaceholders"
            :key="placeHolderIndex"
            :cols="imagesColsXs"
            :sm="imagesColsSm"
            :md="imagesColsMd"
        >
            <v-skeleton-loader v-if="loading" type="image"></v-skeleton-loader>
            <v-responsive v-else aspect-ratio="1">
                <v-bottom-sheet v-model="isBottomSheetOpen">
                    <template #activator="{ props: activatorProps }">
                        <div
                            data-cy="ajout-image"
                            class="w-100 h-100 d-flex justify-center align-center rounded"
                            style="cursor: pointer; border: 2px dashed #999"
                            v-bind="activatorProps"
                        >
                            <v-icon
                                icon="mdi-camera-plus-outline"
                                color="#999"
                                size="x-large"
                            />
                        </div>
                    </template>
                    <v-list>
                        <v-list-item
                            prepend-icon="mdi-folder-image"
                            title="Choisir depuis la galerie"
                            @click="uploadImageWithGalery"
                        >
                        </v-list-item>
                        <v-list-item
                            v-if="hasCamera && isMobile()"
                            prepend-icon="mdi-camera"
                            title="Prendre une photo"
                            @click="uploadImageWithCamera"
                        >
                        </v-list-item>
                        <v-list-item
                            v-if="hasCamera"
                            prepend-icon="mdi-camera-plus"
                            title="Prendre des photos"
                            @click="
                                () => {
                                    isBottomSheetOpen = false
                                    isPhotoCaptureOpen = true
                                }
                            "
                        >
                        </v-list-item>
                    </v-list>
                </v-bottom-sheet>
            </v-responsive>
        </v-col>
    </v-row>
    <s-photo-capture
        v-if="isPhotoCaptureOpen"
        @capture-photo="handleUploadCameraImage"
        @close="isPhotoCaptureOpen = false"
    />
</template>
